%global meadalpha %{nil}
%global meadrel %{nil}
%global version_major 22
%global version_minor 3
%global version_micro 4
%global version_release 0
%global serial 1
%global version_full %{version_major}.%{version_minor}.%{version_micro}.%{version_release}_1
%global mandrel_version %(echo -n %{version_full} | tr '_' '-')b%{serial}

# Commit ids corresponding to the sources listed in the source-repos
# file. These globals are automatically updated by mead (by reading
# the source-repos file) and should be named "commitid" for the first
# source (Source0) and "commitidX" for the following sources, where X
# corresponds to the number of the source (as in SourceX),
%global commitid mandrel-22.3.4.0-Final-1
%global commitid1 6.8.0
%global commitid2 mandrel-22.3.4.0-Final-1

# Workaround for stripping of debug symbols from static libraries
%global __brp_strip_static_archive %{nil}

# Mandrel is sensitive to internal changes of the JDK so we need to make sure
# it is compatible with the installed JDK, thus we require a specific
# jdk version to be installed.
%global jdkversion %(rpm -q --qf '%%{VERSION}-%%{RELEASE}' java-17-openjdk || : )
%global jdkepoch %(rpm -q --qf '%%{EPOCH}:' java-17-openjdk || : )
%global jdkdir %{_jvmdir}/java-17-openjdk-%{jdkversion}.%{_arch}
%global mandrel_temp_dir mandrelJDK

%ifarch x86_64
%global install_arch amd64
%endif

Name:    quarkus-mandrel-22
Version: %{version_full}
Release: %{serial}%{?dist}
Summary: Mandrel
License: GPLv2 with exceptions
URL:     https://github.com/graalvm/mandrel/

Source0: mandrel-%{commitid}.tar.gz
Source1: mx-%{commitid1}.tar.gz
Source2: mandrel-packaging-%{commitid2}.tar.gz

ExclusiveArch: x86_64
# mx 6.8.0 requires at least 3.8+
BuildRequires: python38
# Version 1.8.2-8 has been built with python 3.8 and
# installs ninja-syntax into that python's site packages
# location
BuildRequires: ninja-build >= 1.8.2-8
BuildRequires: java-17-openjdk-static-libs
# Work-around for MANDREL-132 (NPE in debug generation)
BuildRequires: java-17-openjdk-src
BuildRequires: quarkus-mandrel-java-jdk-17-binding = %{version}
BuildRequires: zlib-devel
Requires: java-17-openjdk-static-libs = %{jdkepoch}%{jdkversion}
Requires: quarkus-mandrel-java-jdk-17-binding = %{version}
Requires: zlib-devel
# Post requires alternatives to install tool alternatives
Requires(post):   %{_sbindir}/alternatives
# Postun requires alternatives to uninstall tool alternatives
Requires(postun): %{_sbindir}/alternatives

%description
%{summary}

%prep

if [ -z "%jdkversion" ]
then
    echo "rpm failed to obtain java-17-openjdk version, check BuildRequires"
    exit 11
fi

%setup -q -n mandrel-%{commitid}

%{__mkdir_p} %{_builddir}/mx
%{__tar} xf %{S:1} -C %{_builddir}/mx --strip-components=1

%{__mkdir_p} %{_builddir}/mandrel-packaging
%{__tar} xf %{S:2} -C %{_builddir}/mandrel-packaging --strip-components=1

%build
export PATH=$PATH:%{_builddir}/mx
# mandrel-packging is using MX_PYTHON variable as well for its python
# checking.
export MX_PYTHON=%{_bindir}/python3.8
$MX_PYTHON --version

cp -a %{jdkdir} patched-java
export JAVA_HOME=$(pwd)/patched-java
TOP_DIR=$(pwd)
echo "TOP_DIR=$TOP_DIR"
$JAVA_HOME/bin/java -version

# unzip mandrel-packaging-wrapper
%{__unzip} %{_javadir}/quarkus-mandrel-java/mandrel-packaging-wrapper-linux-amd64.jar
# cp the extracted files to java home
%{__mkdir_p} $JAVA_HOME/lib/svm
%{__cp} -a ./sdk/mxbuild/native-image.properties $JAVA_HOME/lib/svm/macros
%{__mkdir_p} $JAVA_HOME/lib/svm/bin
%{__install} -Dpm0755 sdk/mxbuild/linux-amd64/native-image.image-bash/native-image $JAVA_HOME/lib/svm/bin/

pushd %{_builddir}/mandrel-packaging
$JAVA_HOME/bin/java -ea ./build.java \
    --mx-home %{_builddir}/mx \
    --mandrel-repo $TOP_DIR \
    --mandrel-home %{_builddir}/%{mandrel_temp_dir} \
    --mandrel-version %{mandrel_version} \
    --skip-java \
    --verbose \
    --skip-clean
popd

%install
# Headers and native libs
%{__mkdir} -p %{buildroot}/%{jdkdir}/lib/svm
cp -a %{_builddir}/%{mandrel_temp_dir}/lib/svm/clibraries %{buildroot}/%{jdkdir}/lib/svm/clibraries
ls -la %{_builddir}/%{mandrel_temp_dir}/lib/svm/clibraries %{buildroot}/%{jdkdir}/lib/svm/clibraries

# Progress reporter c lib
%{__mkdir} -p %{buildroot}/%{jdkdir}/lib/svm/builder/lib
cp -a %{_builddir}/%{mandrel_temp_dir}/lib/svm/builder/lib/libreporterchelper.so %{buildroot}/%{jdkdir}/lib/svm/builder/lib

# Macros
cp -a %{_builddir}/%{mandrel_temp_dir}/lib/svm/macros %{buildroot}/%{jdkdir}/lib/svm/macros
ls -la %{_builddir}/%{mandrel_temp_dir}/lib/svm/macros %{buildroot}/%{jdkdir}/lib/svm/macros

# Executable
%{__install} -Dpm0755 %{_builddir}/%{mandrel_temp_dir}/bin/native-image %{buildroot}/%{jdkdir}/lib/svm/bin/native-image
%{__mkdir} %{buildroot}/%{jdkdir}/bin
%{__ln_s} ../lib/svm/bin/native-image %{buildroot}/%{jdkdir}/bin/native-image

# Agents: .so files need at least one exec bit set for
# debuginfo extraction to work with the existing RPM tooling
%{__install} -Dpm0744 %{_builddir}/%{mandrel_temp_dir}/lib/libnative-image-agent.so %{buildroot}/%{jdkdir}/lib/
%{__install} -Dpm0644 %{_builddir}/%{mandrel_temp_dir}/lib/libnative-image-agent.h %{buildroot}/%{jdkdir}/lib/
%{__install} -Dpm0644 %{_builddir}/%{mandrel_temp_dir}/lib/libnative-image-agent_dynamic.h %{buildroot}/%{jdkdir}/lib/
%{__install} -Dpm0744 %{_builddir}/%{mandrel_temp_dir}/lib/libnative-image-diagnostics-agent.so %{buildroot}/%{jdkdir}/lib/
%{__install} -Dpm0644 %{_builddir}/%{mandrel_temp_dir}/lib/libnative-image-diagnostics-agent.h %{buildroot}/%{jdkdir}/lib/
%{__install} -Dpm0644 %{_builddir}/%{mandrel_temp_dir}/lib/libnative-image-diagnostics-agent_dynamic.h %{buildroot}/%{jdkdir}/lib/

# Produce the debugsourcefiles.list manually from 'sources' folder of
# the agents
%{__mkdir} -p %{buildroot}/usr/src/debug
cp -a %{_builddir}/%{mandrel_temp_dir}/lib/sources %{buildroot}/usr/src/debug/%{name}-%{version}-%{release}
pushd %{buildroot}/usr
find src/debug -mindepth 1 -maxdepth 1 | sed 's,^,/usr/,' >> %{_builddir}/debugsourcefiles.list
popd

%check
# Check debug symbols in static libraries (smoke test)
export STATIC_LIBS_HOME=%{buildroot}/%{jdkdir}/lib/svm/clibraries/linux-%{install_arch}/
readelf --debug-dump $STATIC_LIBS_HOME/liblibchelper.a | grep cpuid.c
readelf --debug-dump $STATIC_LIBS_HOME/libjvm.a | grep JvmFuncs.c

%{__cp} -r %{jdkdir} %{_tmppath}/mandrel-test
%{__cp} -nr %{buildroot}/%{jdkdir}/* %{_tmppath}/mandrel-test

pushd %{_tmppath}/mandrel-test
./bin/native-image --version
echo "public class Version{ public static void main(String[] args) {System.out.println(System.getProperty(\"java.runtime.version\"));}}" > Version.java
JDK_VERSION=$(java Version.java)
./bin/native-image --version  | grep -e "^native-image %{mandrel_version} Mandrel Distribution (Java Version ${JDK_VERSION})$"

echo "
public class HelloStrict
{
    public static void main(String[] args)
    {
        System.out.printf(
            \"Hello %1$,.12f %2$,.12f %3$,.12f %n\"
            , StrictMath.cos(0.0)
            , StrictMath.IEEEremainder(3.0, 5.0)
            , StrictMath.IEEEremainder(-16.3, 4.1)
        );
    }
}
" > HelloStrict.java
./bin/javac HelloStrict.java
./bin/java HelloStrict > java.txt
./bin/native-image --report-unsupported-elements-at-runtime HelloStrict
./hellostrict > native.txt
diff java.txt native.txt

popd
%{__rm} -rf %{_tmppath}/mandrel-test

%posttrans
alternatives --add-slave javac %{jdkdir}/bin/javac %{_bindir}/native-image native-image %{jdkdir}/bin/native-image

%postun
alternatives --remove-slave javac %{jdkdir}/bin/javac native-image

%files
%{jdkdir}/lib/svm/clibraries/linux-%{install_arch}/include/amd64cpufeatures.h
%{jdkdir}/lib/svm/clibraries/linux-%{install_arch}/include/aarch64cpufeatures.h
%{jdkdir}/lib/svm/clibraries/linux-%{install_arch}/include/svm_libffi.h
%{jdkdir}/lib/svm/clibraries/linux-%{install_arch}/include/trufflenfi.h
%{jdkdir}/lib/svm/clibraries/linux-%{install_arch}/liblibchelper.a
%{jdkdir}/lib/svm/clibraries/linux-%{install_arch}/libjvm.a
%{jdkdir}/lib/svm/bin/native-image
%{jdkdir}/bin/native-image
%{jdkdir}/lib/svm/macros/native-image-agent-library/native-image.properties
%{jdkdir}/lib/svm/macros/native-image-launcher/native-image.properties
%{jdkdir}/lib/svm/macros/native-image-diagnostics-agent-library/native-image.properties
%{jdkdir}/lib/libnative-image-agent.so
%{jdkdir}/lib/libnative-image-agent.h
%{jdkdir}/lib/libnative-image-agent_dynamic.h
%{jdkdir}/lib/libnative-image-diagnostics-agent.so
%{jdkdir}/lib/libnative-image-diagnostics-agent.h
%{jdkdir}/lib/libnative-image-diagnostics-agent_dynamic.h
%{jdkdir}/lib/svm/builder/lib/libreporterchelper.so

%changelog
* Wed Oct 18 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.4.0_1-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Oct 17 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.3.1_1-2
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Jul 25 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.3.1_1-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Jul 20 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.3.0_1-3
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Jul 18 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.3.0_1-2
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Jul 18 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.3.0_1-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Jul 07 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.2.1_1-5
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Wed May 24 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.2.1_1-4
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Wed May 24 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.2.1_1-3
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue May 23 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.2.1_1-2
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon May 22 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.2.1_1-2
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Apr 28 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.2.1_1-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Apr 18 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.2.0_2-3
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Apr 18 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.2.0_2-2
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Apr 14 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.2.0_2-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Apr 13 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.2.0_1-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Apr 04 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.1.1_1-2
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Mar 31 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.1.1_1-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Wed Mar 29 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.1.1_1-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Mar 28 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.1.1_1-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Jan 27 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.1.0_1-6
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Jan 24 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.1.0_1-5
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Jan 23 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.1.0_1-4
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Jan 20 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.1.0_1-3
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Jan 19 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.1.0_1-2
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Wed Jan 18 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.1.0_1-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Wed Jan 11 2023 cpaas-ops <cpaas-ops@redhat.com> - 22.3.0.1_1-9
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Dec 23 2022 cpaas-ops <cpaas-ops@redhat.com> - 22.3.0.1_1-8
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Dec 22 2022 cpaas-ops <cpaas-ops@redhat.com> - 22.3.0.1_1-7
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Dec 22 2022 cpaas-ops <cpaas-ops@redhat.com> - 22.3.0.1_1-6
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Dec 22 2022 cpaas-ops <cpaas-ops@redhat.com> - 22.3.0.1_1-5
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Dec 01 2022 cpaas-ops <cpaas-ops@redhat.com> - 22.3.0.1_1-4
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Nov 17 2022 cpaas-ops <cpaas-ops@redhat.com> - 22.3.0.1_1-3
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Nov 17 2022 cpaas-ops <cpaas-ops@redhat.com> - 22.3.0.1_1-2
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Thu Nov 17 2022 Severin Gehwolf <sgehwolf@redhat.com> - 22.3.0.1_1-2
- Change package name to quarkus-mandrel-22

* Wed Oct 19 2022 cpaas-ops <cpaas-ops@redhat.com> - 22.3.0.1_1-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Tue Sep 13 2022 cpaas-ops <cpaas-ops@redhat.com> - 22.3.0.0_1-2
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Mon Sep 12 2022 cpaas-ops <cpaas-ops@redhat.com> - 22.3.0.0_1-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Fri Sep 09 2022 cpaas-ops <cpaas-ops@redhat.com> - 22.3.0.0_1-1
- Built by CPaaS
Signed-off-by: sgehwolf <sgehwolf@redhat.com> 

* Wed Sep 07 2022 Severin Gehwolf <sgehwolf@redhat.com> - 22.3.0.0_0-1
- Initial commit
